		.LF DUARTtoVIA.lst
		.CR 65c02
		.IN IttiaraIncludes.asi
		.TF DUARTtoVIA.hex, INT
		.OR PC_START
		.TA ROM_START
		


; this program waits for a character to be received on serial channel A, and
; writes it to VIA port A

		.IN 28L92equates.asi
		.IN 28L92setupTable.asi

ProgStart:
VECTORS = $FFFA
NMI_VEC = VECTORS-1
RST_VEC = ProgStart
IRQ_VEC = NMI_VEC

				;set up VIA
		LDA #$FF		;all outputs
		STA  VIA.DDRA
		;LDA #$00		;
		STA  VIA.IORA
		
				;set up the DUART
		.IN DUARTconfigger.asi
		
		LDA #$55
		STA  VIA.IORA
				;init complete
loopStart:
				;if there is a character available on the DUART, grab it, and put it onto VIA port A and Serial port A
		NOP
		NOP
		NOP
		NOP
		NOP
		
		LDA  DUART.SRA
		AND #%00000001		; I'm only interested in the RxRDY bit
		BEQ  loopStart		; If A=0, then the Rx FIFO is empty
		
		LDA  DUART.FIFOA	; Otherwise, go right ahead and echo the character, and dump it out the VIA
		;STA  DUART.FIFOA
		STA  VIA.IORA
		
		BRA  loopStart
		
				
		.NO VECTORS-1
		RTI
		.DA NMI_VEC, RST_VEC, IRQ_VEC
